<script lang="ts">
import Vue from 'vue';
import { MetaInfo } from 'vue-meta/types/vue-meta';
import { NextStep } from '../components/common/index.vue';
import { SolutionsResourceCards } from '../components/solutions/index.vue';
import {
  Disclaimer,
  GartnerForm,
  Hero,
  IntroCards,
  QuoteCards,
  VideoGroup,
} from '../components/gartner/index.vue';
import { getPageMetadata } from '~/common/meta';
import { LivePreviewMixin } from '~/mixins';
import { ContentfulLivePreview } from '@contentful/live-preview';

export default Vue.extend({
  components: {
    NextStep,
    Hero,
    IntroCards,
    VideoGroup,
    QuoteCards,
    GartnerForm,
    SolutionsResourceCards,
    Disclaimer,
  },
  mixins: [LivePreviewMixin],
  nuxtI18n: {
    locales: ['ja-jp', 'en-us'],
  },
  async asyncData({ $gartnerMagicQuadrantService }: any) {
    try {
      const { gartner, items } =
        await $gartnerMagicQuadrantService.getContent();

      return { gartner, items };
    } catch (e) {
      throw new Error(e);
    }
  },
  head(): MetaInfo {
    return getPageMetadata(
      (this as any).gartner,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
  mounted() {
    if (this.isPreview) {
      const unsubscribeFn = ContentfulLivePreview.subscribe({
        data: this.items,
        callback: (updatedData) =>
          (this.gartner =
            this.$gartnerMagicQuadrantService.transformContentfulData(
              updatedData,
            )),
      });

      this.livePreviewSubscriptions.push(unsubscribeFn);
    }
  },
});
</script>

<template>
  <div v-if="gartner">
    <SlpContainer v-if="gartner.hero" id="hero" variant="gradient">
      <!-- <Sparkle :scale="1.5" :animation-delay="3" class="sparkle sparkle-1" />
      <Sparkle :scale="1.5" :animation-delay="1" class="sparkle sparkle-2" />
      <Sparkle :scale="1" :animation-delay="3" class="sparkle sparkle-3" />
      <Sparkle :scale="0.7" :animation-delay="5" class="sparkle sparkle-4" />
      <Sparkle :scale="1" :animation-delay="2" class="sparkle sparkle-5" /> -->
      <Hero v-bind="gartner.hero" />
    </SlpContainer>
    <div v-if="gartner.intro_cards" id="intro">
      <!-- <Sparkle :scale="1.5" :animation-delay="2" class="sparkle sparkle-1" />
      <Sparkle :scale="1.5" :animation-delay="5" class="sparkle sparkle-2" />
      <Sparkle :scale="1" :animation-delay="2" class="sparkle sparkle-3" /> -->
      <SlpContainer>
        <IntroCards v-bind="gartner.intro_cards" />
      </SlpContainer>
    </div>
    <div v-if="gartner.videos" id="videos">
      <!-- <Sparkle :scale="1.5" :animation-delay="3" class="sparkle sparkle-1" />
      <Sparkle :scale="1.5" :animation-delay="1" class="sparkle sparkle-2" />
      <Sparkle :scale="1" :animation-delay="4" class="sparkle sparkle-3" /> -->
      <SlpContainer>
        <VideoGroup :videos="gartner.videos" />
      </SlpContainer>
    </div>
    <SlpContainer v-if="gartner.quotes" id="quotes">
      <!-- <Sparkle :scale="1.5" :animation-delay="1" class="sparkle sparkle-1" />
      <Sparkle :scale="1" :animation-delay="4" class="sparkle sparkle-2" /> -->
      <QuoteCards v-bind="gartner.quotes" />
    </SlpContainer>
    <SlpContainer v-if="gartner.resources && $i18n.locale === 'en-us'">
      <SolutionsResourceCards v-bind="gartner.resources" />
    </SlpContainer>
    <SlpContainer v-if="gartner.form" id="form">
      <!-- <Sparkle :scale="1.5" :animation-delay="1" class="sparkle sparkle-1" />
      <Sparkle :scale="1" :animation-delay="4" class="sparkle sparkle-2" /> -->
      <GartnerForm v-bind="gartner.form" />
    </SlpContainer>
    <SlpContainer variant="gradient">
      <NextStep />
    </SlpContainer>
    <Disclaimer v-if="gartner.disclaimer" v-bind="gartner.disclaimer" />
  </div>
</template>

<style lang="scss" scoped>
// CSS only for the decoration sparks
// Commented for now, see: https://gitlab.com/gitlab-com/marketing/digital-experience/buyer-experience/-/merge_requests/2433#note_1432992007
.sparkle {
  @media (max-width: $breakpoint-lg) {
    display: none;
  }
}
#hero {
  position: relative;
  .sparkle {
    position: absolute;
    &-1 {
      bottom: 10%;
      right: 5%;
    }
    &-2 {
      right: 20%;
      top: 5%;
    }
    &-3 {
      top: 10%;
      right: 25%;
    }
    &-4 {
      left: 10%;
      top: 15%;
    }
    &-5 {
      left: 5%;
      top: 50%;
    }
  }
}
#intro {
  position: relative;
  .sparkle {
    position: absolute;
    &-1 {
      top: 5%;
      right: 5%;
    }
    &-2 {
      top: 10%;
      right: 15%;
    }
    &-3 {
      left: 15%;
      top: 25%;
    }
  }
}
#videos {
  position: relative;
  .sparkle {
    position: absolute;
    &-1 {
      left: 20%;
      top: 45%;
    }
    &-2 {
      left: 15%;
      top: 50%;
    }
    &-3 {
      left: 20%;
      bottom: 10%;
    }
  }
}
#quotes {
  position: relative;
  .sparkle {
    position: absolute;
    &-1 {
      top: 7%;
      right: 5%;
    }
    &-2 {
      top: 12%;
      right: 15%;
    }
  }
}
#form {
  position: relative;
  .sparkle {
    position: absolute;
    &-1 {
      top: 7%;
      left: 5%;
    }
    &-2 {
      top: 12%;
      left: 15%;
    }
  }
}
</style>
